use shiny_std::arena::intern;

use crate::ptr::{self, TaggedTy};

pub type Ts = intern::Arena<TaggedTy, ptr::Ty>;

pub struct Ctx {
    ts: Ts,
}

impl Ctx {
    pub fn new(ts: Ts) -> Self {
        Self { ts }
    }
}

impl Ctx {
    pub fn get_type(&self, ptr: ptr::Ty) -> Option<TaggedTy> {
        self.ts.get(ptr).cloned()
    }
}
