//! # Pointers to needed information.
//!
//! If values are equal, then their pointers are equal.
//! This means that there's unambiguous mapping from id to value and
//! back.

use crate::bin;

use shiny_std::arena::ptr::define;

#[derive(Debug, Clone, Copy, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum TaggedTy {
    Prod(bin::Prod),
    Sum(bin::Sum),
    Number,
    Str,
}

define! {
    /// Pointer to a type.
    pub struct Ty;

    /// Pointer to ID.
    pub struct Id;

    /// Pointer to a pattern.
    pub struct Pat;

    /// Pointer to a *complete* value.
    pub struct Value;
}
